/* Program pro ovladani dvou motoru s radicem L298 zadavani volby pohonu modelu,
 * smeru chodu jednoho, dvou motoru a otacek je z BLUETOOTH JDY-33 
 * terminalem pro seriovou komunikaci,tabletem, telefonem
 * jde o upraveny program tak aby nemohlo dojit k poskozeni modulu L298
  vagnervlastimil@seznam.cz
*/
#include <SoftwareSerial.h>
SoftwareSerial  BT(10,11);      //PIN10 vstup RXD, PIN11 výstup TXD komunikace s BLUETOOTH JDY-33 (HC-06)
const int motorA_A = 8;         //volba smeru chodu motoru "A" vlevo vstup L298-IN1 (PIN8)                  
const int motorA_B = 7;         //volba smeru chodu motoru "A" vpravo vstup L298-IN2 (PIN7) 
const int otackyA = 9;          //otacky PWM motoru A vstup L298 enable motor A (PIN9) 
const int otackyB = 3;          //otacky PWM motoru B vstup L298 enable motor B (PIN3)
const int motorB_B = 4;         //volba smeru chodu motoru "B" vlevo vstup L298-IN4 (PIN4)
const int motorB_A = 5;         //volba smeru chodu motoru "B" vpravo vstup L298-IN3 (PIN5)

int smerA;                      //volba smeru chodu motoru "A" vlevo A_A IN1 (PIN8)
int smerB;                      //volba smeru chodu motoru "A" vpravoA_B IN2 (PIN7)
int smerC;                      //volba smeru chodu motoru "B" vlevoB_B IN4 (PIN4)
int smerD;                      //volba smeru chodu motoru "B" vpravoB_A IN3 (PIN5)
int motorotA;                   //volba rychlosti PWM motoru "A" (PIN9)
int motorotB;                   //volba rychlosti PWM motoru "B" (PIN3) 

void setup(){                   //zadani parametru
pinMode(motorA_A,OUTPUT);       //nastaveni PINU 8 (motorA_A) na vystup motor "A" vlevo (IN1-L298)
pinMode(motorA_B,OUTPUT);       //nastaveni PINU 7 (motorA_B) na vystup motor "A" vpravo (IN2-L298)
pinMode(otackyA,OUTPUT);        //nastaveni PINU 9 (otackyA) na vystup PWM pro motor "A"
pinMode(otackyB,OUTPUT);        //nastaveni PINU 3 (otackyB) na vystup PWM pro motor "B"
pinMode(motorB_B,OUTPUT);       //nastaveni PINU 4 (motorB_B) na vystup motor "B" vlevo (IN4-L298)
pinMode(motorB_A,OUTPUT);       //nastaveni PINU 5 (motorB_A) na vystup motor "B" vpravo (IN3-L298)
BT.begin(9600);                 //funkce pro komunikaci s BLUETOOTH JDY-33 (HC-06) 
}

void loop(){                      //hlavni program
if (BT.available() > 0){          //testovani vstupu zda prisli data   
smer();                           //zavolani funkce na vypnuti vsech vystupu L298
smerA=BT.parseInt();              //nacteni hodnoty pro smer otaceni motoru "A" vlevo IN1 PIN8
smerB=BT.parseInt();              //nacteni hodnoty pro smer otaceni motoru "A" vpravo IN2 PIN7
smerC=BT.parseInt();              //nacteni hodnoty pro smer otaceni motoru "B" vlevo IN3 PIN4
smerD=BT.parseInt();              //nacteni hosnoty pro smer otaceni motoru "B" vpravo IN4 PIN5
motorotA=BT.parseInt();           //nacteni hodnoty PWM pro motor "A" PIN9 
motorotB=BT.parseInt();           //nacteni hodnoty PWM pro motor "B" PIN3
BT.print(smerA);                  //odeslani nactene hodnoty v promenne "smerA" zobrazeni na tabletu
BT.print(smerB);                  //odeslani nactene hodnoty v promenne "smerB" zobrazeni na tabletu
BT.print(smerC);                  //odeslani nactene hodnoty v promenne "smeC" zobrazeni na tabletu
BT.print(smerD);                  //odeslani nactene hodnoty v promenne "smerD" zobrazeni na tabletu
BT.print(motorotA);               //nactena hodnota "motorotA" pro PWM motor "A" zobrazeni na tabletu
BT.print(motorotB);               //nactena hodnota "motorotB" pro PWM motor "B" zobrazeni na tabletu
if(smerA==1 && smerB==1){         //porovnani smerA AND smerB
chyba();}                         //skok na funkci chyba  
if(smerB==1 && smerA==1){         //porovnani smerB AND smerA 
chyba();}                         //skok na funkci chyba   
if(smerC==1 && smerD==1){         //porovnani smerC AND smerD
chyba();}                         //skok na funkci chyba 
if(smerD==1 && smerC==1){         //porovnani smerD AND smerC
chyba();}                         //skok na funkci chyba 
}                                 //konec smycky available
if (smerA==1){                    //pokud je smerA roven "1" pokracuje se na dalsim radku
digitalWrite(motorA_A,HIGH);      //zapnuti vystupu IN1 chod motoru "A" vlevo
analogWrite(otackyA,motorotA);}   //nastaveni vystupu PWM motoru "A" dle hodnoty "motorotA"
else{                             //pokud hodnota smerA je roven "0" pokracje na dalsim radku
digitalWrite(motorA_A,LOW);}      //vypnuti vystupu IN1 vypnuti motoru "A" chod vlevo  
if(smerB==1){                     //pokud je smerB roven "1" pokracuje se na dalsim radku  
digitalWrite(motorA_B,HIGH);      //zapnuti vystupu IN2 chod motoru "A" vpravo
analogWrite(otackyA,motorotA);}   //nastaveni vystupu PWM motoru"A" dle hodnoty "motorotA"
else{                             //pokud hodnota smerB je roven "0" pokracje na dalsim radku
digitalWrite(motorA_B,LOW);}      //vypnuti vystupu IN2 chod motoru "A" vpravo
if (smerC==1){                    //pokud je smerC roven "1" pokracuje se na dalsim radku  
digitalWrite(motorB_B,HIGH);      //zapnuti vystupu IN4 chod motoru "B" vlevo   
analogWrite(otackyB,motorotB);}   //nastaveni vystupu PWM motoru "B" dle hodnoty "motorotB
else{                             //pokud hodnota smerC je roven "0" pokracje na dalsim radku
digitalWrite(motorB_B,LOW);}      //vypnuti vystupu IN4 chod motoru "B" vlevo   
if (smerD==1){                    //pokud je smerD roven "1" pokracuje se na dalsim radku  
digitalWrite(motorB_A,HIGH);      //zapnuti vystupu IN3 chod motoru "B" vpravo  
analogWrite(otackyB,motorotB);}   //nastaveni vystupu PWM motoru "B" dle hodnoty motorotB
else{                             //pokud hodnota smerD je roven "0" pokracuje na dalsim radku
digitalWrite(motorB_A,LOW);}      //vypnuti vystupu IN3 chod motoru "B" vpravo
}                                 //po odladeni programu mozno radky BT.print(smerA az BT.println(motorotB) smazat
// podprogramy pro vypnuti vystupu proti zniceni obvodu L298
void smer(){                      //funkce vypnuti vsech vystupu ochrana L298
motorotA = 0;                     //promenna motorotA na hodnotu "0"
motorotB = 0;                     //promenna motorotB na hodnotu "0"
digitalWrite(motorA_A,LOW);       //vypnuti vystupu IN1 chod motoru "A" vlevo
digitalWrite(motorA_B,LOW);       //vypnuti vystupu IN2 chod motoru "A" vpravo
analogWrite(otackyA,motorotA);    //nastaveni vystupu PWM motoru "A" na hodnotu "motorotA"
digitalWrite(motorB_B,LOW );      //vypnuti vystupu IN4 chod motoru "B" vlevo   
digitalWrite(motorB_A,LOW);       //vypnuti vystupu IN3 chod motoru "B" vpravo      
analogWrite(otackyB,motorotB);    //nastaveni vystupu PWM motoru "B" na hodnotu "motorotB"
delay(1000);                      //casova prodleva pro vypnuti vystupu L298
BT.println("ZMENA JIZDY");        //zobrazeni zmeny jizdy vpred - vzad na LCD tabletu
}                                 //konec smycky smer

void chyba (){                    //zacatek smycky chyba
motorotA = 0;                     //promenna motorotA na hodnotu "0"
motorotB = 0;                     //promenna motorotB na hodnotu "0"
digitalWrite(motorA_A,LOW);       //vypnuti vystupu IN1 chod motoru "A" vlevo
digitalWrite(motorA_B,LOW);       //vypnuti vystupu IN2 chod motoru "A" vpravo
analogWrite(otackyA,motorotA);    //nastaveni vystupu PWM motoru "A" na hodnotu "motorotA"
digitalWrite(motorB_B,LOW );      //vypnuti vystupu IN4 chod motoru "B" vlevo   
digitalWrite(motorB_A,LOW);       //vypnuti vystupu IN3 chod motoru "B" vpravo      
analogWrite(otackyB,motorotB);    //nastaveni vystupu PWM motoru "B" na hodnotu "motorotB"
BT.println("CHYBA ZADANI HODNOT"); //zmena jizdy vpred - vzad  
}                                 //konec smycky chyba

     
     
